VarFunTrue <- function(phi1, phi2, sigma = 1){
    S <- matrix(0,ncol=2, nrow=3)
    S[1, ] <- 1
    S[2:3,1:2] <- diag(2)

    gamma.true <- gamma.true.fun(phi1,phi2,sigma)
    rho1A.true <- (gamma.true[2] + 2 * gamma.true[3] + gamma.true[4]) / (2 * (gamma.true[1]+gamma.true[2]))
    
    Phi <- Phi.fun(phi1,phi2)
    Phi.epsilon <- Phi.epsilon.fun(phi1,phi2)

    
    Gamma <- Gamma.fun(rho.true.fun(phi1,phi2)[1],rho1A.true)
    ## eq (A.7)
    VyH <- matrix(gamma.true[2],ncol=2,nrow=2)
    diag(VyH) <- gamma.true[1]
    
    ## eq (A.6)
    Sigma <- (Phi-Gamma) %*% VyH %*% t(Phi-Gamma) + sigma^2 * Phi.epsilon %*% t(Phi.epsilon)
    
    Sigma.re <- Sigma
    Sigma.re[1,-1] <- Sigma.re[-1,1] <- 0
    
    ## Projection matrices
    Pfull <- solve(t(S) %*% solve(Sigma) %*% S) %*% t(S) %*% solve(Sigma)
    Pre <- solve(t(S) %*% solve(Sigma.re) %*% S) %*% t(S) %*% solve(Sigma.re)
    
    ## eq (A.8)
    Sigma.tilde <- (Phi-S%*%Pfull%*%Gamma) %*% VyH %*% t(Phi-S%*%Pfull%*%Gamma) +
        sigma^2 * Phi.epsilon %*% t(Phi.epsilon)
    Sigma.tilde.re <- (Phi - S %*% Pre %*% Gamma) %*% VyH %*% t(Phi-S %*% Pre %*% Gamma) +
        sigma^2 * Phi.epsilon %*% t(Phi.epsilon)
    
    ## Perfect forecast
    Sigma.perf <- sigma^2 * Phi.epsilon %*% t(Phi.epsilon)
    
    return(list(Sigma = Sigma, Sigma.tilde = Sigma.tilde, Sigma.tilde.re = Sigma.tilde.re, 
                Sigma.perf = Sigma.perf, Pfull = Pfull, Pre = Pre))
}
